module.exports = {
  "parser": "babel-eslint",
  "extends": "eslint:recommended",
  "plugins": [
    "react",
    "jest",
  ],
  "env": {
    "browser": true,
    "node": true,
    "mocha": true,
    "es6": true,
    "jest/globals": true,
  },
  "parserOptions": {
    "ecmaFeatures": {
      "modules": true,
      "jsx": true,
    },
  },
  "settings": {
    "react": {
      "pragma": "h",
    },
  },
  "globals": {
    "sleep": 1,
  },
  "rules": {
    // only allow JSX in .test.js files
    "react/jsx-filename-extension": [2, { "extensions": [".test.js"] }],
    // disabled because we are only using JSX in tests
    "react/jsx-no-bind": [0],
    "react/jsx-no-duplicate-props": 2,
    "react/self-closing-comp": 2,
    "react/prefer-es6-class": 2,
    "react/no-string-refs": 2,
    "react/require-render-return": 2,
    "react/no-find-dom-node": 2,
    "react/no-is-mounted": 2,
    "react/jsx-no-comment-textnodes": 2,
    "react/jsx-curly-spacing": 2,
    "react/jsx-no-undef": 2,
    "react/jsx-uses-react": 2,
    "react/jsx-uses-vars": 2,
    "jest/no-disabled-tests": 1,
    "jest/no-focused-tests": 1,
    "jest/no-identical-title": 2,
    "camelcase": 0,
    "comma-dangle": [2, {
      "arrays": "always-multiline",
      "objects": "always-multiline",
      "imports": "always-multiline",
      "exports": "always-multiline",
      // make eslint catch any trailing comma in function argument list as an error
      "functions": "never",
    }],
    "comma-style": 2,
    "constructor-super": 2,
    "eqeqeq": 1,
    "guard-for-in": 2,
    "handle-callback-err": 0,
    "indent": [2, 2, {"SwitchCase": 1}],
    "keyword-spacing": 2,
    "max-nested-callbacks": [2, 3],
    "no-cond-assign": 1,
    "no-console": 0,
    "no-const-assign": 2,
    "no-delete-var": 2,
    "no-dupe-class-members": 2,
    "no-dupe-keys": 2,
    "no-else-return": 2,
    "no-empty": 0,
    "no-empty-pattern": 0,
    "no-eval": 2,
    "no-implied-eval": 2,
    "no-lonely-if": 2,
    "no-mixed-spaces-and-tabs": [2, "smart-tabs"],
    "no-new-func": 2,
    "no-redeclare": 2,
    "no-shadow": 0,
    "no-shadow-restricted-names": 2,
    "no-this-before-super": 2,
    "no-trailing-spaces": [2, { "skipBlankLines": true }],
    "no-undef-init": 2,
    "no-useless-concat": 2,
    "no-var": 2,
    "object-shorthand": 2,
    "prefer-arrow-callback": 2,
    "prefer-spread": 2,
    "radix": 2,
    "semi": 2,
    "strict": [2, "never"],
    "space-in-parens": [2, "never"],
  },
};
